
/*****************************************************************************
 *                                                                           *
 *  PMB source code, MPI-1 part                           ---/---            *
 *                                                          / /              *
 *  Copyright (c) PALLAS GmbH 1998                         / / /             *
 *                                                        / / / /            *
 *                                                         / / /             *
 *  Authors: Hans-Joachim Plum , Gero Ritzenhoefer          / / PALLAS       *
 *  Revision: 2.0                                         ---/---            *
 *  Date: 1998/03/10                                                         *
 *                                                                           *
 *****************************************************************************/

/*****************************************************************************
Definition of a descriptor type "Bench" for benchmarks
*****************************************************************************/

/* Classification of benchmarks */

typedef enum { BTYPE_INVALID=-1,
               SingleTransfer,
               MultiTransfer,
               Global
             } BTYPES;

/* Descriptor for benchmarks */

struct Bench
  {
  char*  name;
  char** bench_comments;       /* Comments from header => Comments.h */
  BTYPES type;

  void (*Benchmark)(struct comm_info* c_info,int size,
                    int n_sample,double* time);
                               /* Pointer to function runnning the benchmark */

  double scale_time, scale_bw; /* Scaling of timings and bandwidth */
  };
