
/*****************************************************************************
 *                                                                           *
 *  PMB source code, MPI-1 part                           ---/---            *
 *                                                          / /              *
 *  Copyright (c) PALLAS GmbH 1998                         / / /             *
 *                                                        / / / /            *
 *                                                         / / /             *
 *  Authors: Hans-Joachim Plum , Gero Ritzenhoefer          / / PALLAS       *
 *  Revision: 2.0                                         ---/---            *
 *  Date: 1998/03/10                                                         *
 *                                                                           *
 *****************************************************************************/
/*****************************************************************************
 *                                                                           *
 *  PMB source code                                       ---/---            *
 *                                                          / /              *
 *  Copyright (c) PALLAS GmbH 1997                         / / /             *
 *                                                        / / / /            *
 *                                                         / / /             *
 *  Author: Hans-Joachim Plum , Gero Ritzenhoefer           / / PALLAS       *
 *  Revision: 1.2                                         ---/---            *
 *  Date: 1997/07/31                                                         *
 *                                                                           *
 *****************************************************************************/
#ifndef _COMM_INFO_H
#define _COMM_INFO_H 

struct comm_info
{ 
int w_num_procs;          /* number of procs in COMM_WORLD            */
int w_rank;               /* rank of actual process in COMM_WORLD     */

int NP;                   /* #processes participating in benchmarks   */

MPI_Comm communicator;    /* underlying communicator for benchmark(s) */

int num_procs;            /* number of processes in communicator      */
int rank;                 /* rank of actual process in communicator   */

MPI_Datatype s_data_type; /* data type of sent data                   */
MPI_Datatype r_data_type; /* data type of received data               */

MPI_Datatype red_data_type;/* data type of reduced data               */
MPI_Op op_type;            /* operation type                          */

int pair0, pair1;          /* process pair                            */
int select_tag;            /* 0/1 for tag selection off/on            */
int select_source;         /* 0/1 for sender selection off/on         */

void* s_buffer;            /* send    buffer                          */
int   s_alloc;             /* #bytes allocated in s_buffer            */
void* r_buffer;            /* receive buffer                          */
int   r_alloc;             /* #bytes allocated in r_buffer            */

int group_mode;            /* Mode of running groups (<0,0,>0)        */
int n_groups;              /* No. of independent groups               */
int* g_sizes;              /* array of group sizes                    */
int* g_ranks;              /* w_ranks constituting the groups         */

int* reccnt;               /* recv count argument for global ops.     */
int* displs;               /* displacement argument for global ops.   */
};

#endif
